diff --git a/dlls/quartz/vmr9.c b/dlls/quartz/vmr9.c
index 2330f8fc0..4bde811c6 100644
--- a/dlls/quartz/vmr9.c
+++ b/dlls/quartz/vmr9.c
@@ -33,7 +33,6 @@
 #include "ddraw.h"
 #include "dvdmedia.h"
 #include "d3d9.h"
-#include "videoacc.h"
 #include "vmr9.h"
 
 #include "wine/debug.h"
@@ -79,7 +78,6 @@ struct quartz_vmr
      * Native uses a separate reference count for IVMRSurfaceAllocatorNotify9. */
     LONG IVMRSurfaceAllocatorNotify9_refcount;
 
-    IAMVideoAccelerator IAMVideoAccelerator_iface;
     IOverlay IOverlay_iface;
 
     IVMRSurfaceAllocator9 *allocator;
@@ -246,7 +244,7 @@ static HRESULT vmr_render(struct strmbase_renderer *iface, IMediaSample *sample)
 
     if (FAILED(hr = IMediaSample_GetPointer(sample, &data)))
     {
-        ERR("Failed to get pointer to sample data, hr %#lx.\n", hr);
+        ERR("Failed to get pointer to sample data, hr %#x.\n", hr);
         return hr;
     }
     data_size = IMediaSample_GetActualDataLength(sample);
@@ -269,7 +267,7 @@ static HRESULT vmr_render(struct strmbase_renderer *iface, IMediaSample *sample)
 
     if (FAILED(hr = IDirect3DSurface9_LockRect(info.lpSurf, &locked_rect, NULL, D3DLOCK_DISCARD)))
     {
-        ERR("Failed to lock surface, hr %#lx.\n", hr);
+        ERR("Failed to lock surface, hr %#x.\n", hr);
         return hr;
     }
 
@@ -334,7 +332,7 @@ static HRESULT initialize_device(struct quartz_vmr *filter, VMR9AllocationInfo *
     if (FAILED(hr = IVMRSurfaceAllocator9_InitializeDevice(filter->allocator,
             filter->cookie, info, &count)))
     {
-        WARN("Failed to initialize device (flags %#lx), hr %#lx.\n", info->dwFlags, hr);
+        WARN("Failed to initialize device (flags %#x), hr %#x.\n", info->dwFlags, hr);
         return hr;
     }
 
@@ -343,7 +341,7 @@ static HRESULT initialize_device(struct quartz_vmr *filter, VMR9AllocationInfo *
         if (FAILED(hr = IVMRSurfaceAllocator9_GetSurface(filter->allocator,
                 filter->cookie, i, 0, &filter->surfaces[i])))
         {
-            ERR("Failed to get surface %lu, hr %#lx.\n", i, hr);
+            ERR("Failed to get surface %u, hr %#x.\n", i, hr);
             while (i--)
                 IDirect3DSurface9_Release(filter->surfaces[i]);
             IVMRSurfaceAllocator9_TerminateDevice(filter->allocator, filter->cookie);
@@ -427,7 +425,7 @@ static HRESULT allocate_surfaces(struct quartz_vmr *filter, const AM_MEDIA_TYPE
             break;
 
         default:
-            WARN("Unhandled video compression %#lx.\n", filter->bmiheader.biCompression);
+            WARN("Unhandled video compression %#x.\n", filter->bmiheader.biCompression);
             free(filter->surfaces);
             return VFW_E_TYPE_NOT_ACCEPTED;
         }
@@ -612,9 +610,7 @@ static HRESULT vmr_pin_query_interface(struct strmbase_renderer *iface, REFIID i
 {
     struct quartz_vmr *filter = impl_from_IBaseFilter(&iface->filter.IBaseFilter_iface);
 
-    if (IsEqualGUID(iid, &IID_IAMVideoAccelerator))
-        *out = &filter->IAMVideoAccelerator_iface;
-    else if (IsEqualGUID(iid, &IID_IOverlay))
+    if (IsEqualGUID(iid, &IID_IOverlay))
         *out = &filter->IOverlay_iface;
     else
         return E_NOINTERFACE;
@@ -886,12 +882,11 @@ static HRESULT WINAPI VMR7FilterConfig_SetImageCompositor(IVMRFilterConfig *ifac
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI VMR7FilterConfig_SetNumberOfStreams(IVMRFilterConfig *iface, DWORD count)
+static HRESULT WINAPI VMR7FilterConfig_SetNumberOfStreams(IVMRFilterConfig *iface, DWORD max)
 {
-    struct quartz_vmr *filter = impl_from_IVMRFilterConfig(iface);
-
-    FIXME("filter %p, count %lu, stub!\n", filter, count);
+    struct quartz_vmr *This = impl_from_IVMRFilterConfig(iface);
 
+    FIXME("(%p/%p)->(%u) stub\n", iface, This, max);
     return E_NOTIMPL;
 }
 
@@ -903,12 +898,11 @@ static HRESULT WINAPI VMR7FilterConfig_GetNumberOfStreams(IVMRFilterConfig *ifac
     return E_NOTIMPL;
 }
 
-static HRESULT WINAPI VMR7FilterConfig_SetRenderingPrefs(IVMRFilterConfig *iface, DWORD flags)
+static HRESULT WINAPI VMR7FilterConfig_SetRenderingPrefs(IVMRFilterConfig *iface, DWORD renderflags)
 {
-    struct quartz_vmr *filter = impl_from_IVMRFilterConfig(iface);
-
-    FIXME("filter %p, flags %#lx, stub!\n", filter, flags);
+    struct quartz_vmr *This = impl_from_IVMRFilterConfig(iface);
 
+    FIXME("(%p/%p)->(%u) stub\n", iface, This, renderflags);
     return E_NOTIMPL;
 }
 
@@ -924,7 +918,7 @@ static HRESULT WINAPI VMR7FilterConfig_SetRenderingMode(IVMRFilterConfig *iface,
 {
     struct quartz_vmr *filter = impl_from_IVMRFilterConfig(iface);
 
-    TRACE("iface %p, mode %#lx.\n", iface, mode);
+    TRACE("iface %p, mode %#x.\n", iface, mode);
 
     return IVMRFilterConfig9_SetRenderingMode(&filter->IVMRFilterConfig9_iface, mode);
 }
@@ -1110,7 +1104,7 @@ static HRESULT WINAPI VMR7MonitorConfig_GetAvailableMonitors(IVMRMonitorConfig *
     struct quartz_vmr *This = impl_from_IVMRMonitorConfig(iface);
     struct get_available_monitors_args args;
 
-    TRACE("filter %p, info %p, arraysize %lu, numdev %p.\n", This, info, arraysize, numdev);
+    FIXME("(%p/%p)->(%p, %u, %p) semi-stub\n", iface, This, info, arraysize, numdev);
 
     if (!numdev)
         return E_POINTER;
@@ -1210,7 +1204,7 @@ static HRESULT WINAPI VMR9MonitorConfig_GetAvailableMonitors(IVMRMonitorConfig9
     struct quartz_vmr *This = impl_from_IVMRMonitorConfig9(iface);
     struct get_available_monitors_args args;
 
-    TRACE("filter %p, info %p, arraysize %lu, numdev %p.\n", This, info, arraysize, numdev);
+    FIXME("(%p/%p)->(%p, %u, %p) semi-stub\n", iface, This, info, arraysize, numdev);
 
     if (!numdev)
         return E_POINTER;
@@ -1270,7 +1264,7 @@ static HRESULT WINAPI VMR9FilterConfig_SetNumberOfStreams(IVMRFilterConfig9 *ifa
 {
     struct quartz_vmr *filter = impl_from_IVMRFilterConfig9(iface);
 
-    FIXME("iface %p, count %lu, stub!\n", iface, count);
+    FIXME("iface %p, count %u, stub!\n", iface, count);
 
     if (!count)
     {
@@ -1313,12 +1307,11 @@ static HRESULT WINAPI VMR9FilterConfig_GetNumberOfStreams(IVMRFilterConfig9 *ifa
     return S_OK;
 }
 
-static HRESULT WINAPI VMR9FilterConfig_SetRenderingPrefs(IVMRFilterConfig9 *iface, DWORD flags)
+static HRESULT WINAPI VMR9FilterConfig_SetRenderingPrefs(IVMRFilterConfig9 *iface, DWORD renderflags)
 {
-    struct quartz_vmr *filter = impl_from_IVMRFilterConfig9(iface);
-
-    TRACE("filter %p, flags %#lx.\n", filter, flags);
+    struct quartz_vmr *This = impl_from_IVMRFilterConfig9(iface);
 
+    FIXME("(%p/%p)->(%u) stub\n", iface, This, renderflags);
     return E_NOTIMPL;
 }
 
@@ -1335,7 +1328,7 @@ static HRESULT WINAPI VMR9FilterConfig_SetRenderingMode(IVMRFilterConfig9 *iface
     HRESULT hr = S_OK;
     struct quartz_vmr *This = impl_from_IVMRFilterConfig9(iface);
 
-    TRACE("filter %p, mode %lu.\n", This, mode);
+    TRACE("(%p/%p)->(%u)\n", iface, This, mode);
 
     EnterCriticalSection(&This->renderer.filter.filter_cs);
     if (This->mode)
@@ -1360,14 +1353,14 @@ static HRESULT WINAPI VMR9FilterConfig_SetRenderingMode(IVMRFilterConfig9 *iface
 
         if (FAILED(hr = VMR9DefaultAllocatorPresenterImpl_create(This, (void **)&This->presenter)))
         {
-            ERR("Failed to create default presenter, hr %#lx.\n", hr);
+            ERR("Failed to create default presenter, hr %#x.\n", hr);
             break;
         }
 
         if (FAILED(hr = IVMRImagePresenter9_QueryInterface(This->presenter,
                     &IID_IVMRSurfaceAllocator9, (void **)&This->allocator)))
         {
-            ERR("Failed to query for IVMRSurfaceAllocator9, hr %#lx.\n", hr);
+            ERR("Failed to query for IVMRSurfaceAllocator9, hr %#x.\n", hr);
             IVMRImagePresenter9_Release(This->presenter);
             This->allocator = NULL;
             This->presenter = NULL;
@@ -1727,7 +1720,7 @@ static HRESULT WINAPI VMR9WindowlessControl_SetAspectRatioMode(IVMRWindowlessCon
 {
     struct quartz_vmr *filter = impl_from_IVMRWindowlessControl9(iface);
 
-    TRACE("filter %p, mode %lu.\n", filter, mode);
+    TRACE("filter %p, mode %u.\n", filter, mode);
 
     EnterCriticalSection(&filter->renderer.filter.filter_cs);
     filter->aspect_mode = mode;
@@ -1943,7 +1936,7 @@ static ULONG WINAPI VMR9SurfaceAllocatorNotify_AddRef(IVMRSurfaceAllocatorNotify
     struct quartz_vmr *filter = impl_from_IVMRSurfaceAllocatorNotify9(iface);
     ULONG refcount = InterlockedIncrement(&filter->IVMRSurfaceAllocatorNotify9_refcount);
 
-    TRACE("%p increasing refcount to %lu.\n", iface, refcount);
+    TRACE("%p increasing refcount to %u.\n", iface, refcount);
 
     return refcount;
 }
@@ -1953,7 +1946,7 @@ static ULONG WINAPI VMR9SurfaceAllocatorNotify_Release(IVMRSurfaceAllocatorNotif
     struct quartz_vmr *filter = impl_from_IVMRSurfaceAllocatorNotify9(iface);
     ULONG refcount = InterlockedDecrement(&filter->IVMRSurfaceAllocatorNotify9_refcount);
 
-    TRACE("%p decreasing refcount to %lu.\n", iface, refcount);
+    TRACE("%p decreasing refcount to %u.\n", iface, refcount);
 
     if (!refcount && !filter->renderer.filter.refcount)
         free(filter);
@@ -2038,7 +2031,7 @@ static HRESULT WINAPI VMR9SurfaceAllocatorNotify_AllocateSurfaceHelper(IVMRSurfa
     if (!allocinfo || !numbuffers || !surface)
         return E_POINTER;
 
-    TRACE("Flags %#lx, size %lux%lu, format %u (%#x), pool %u, minimum buffers %lu.\n",
+    TRACE("Flags %#x, size %ux%u, format %u (%#x), pool %u, minimum buffers %u.\n",
             allocinfo->dwFlags, allocinfo->dwWidth, allocinfo->dwHeight,
             allocinfo->Format, allocinfo->Format, allocinfo->Pool, allocinfo->MinBuffers);
 
@@ -2063,7 +2056,7 @@ static HRESULT WINAPI VMR9SurfaceAllocatorNotify_AllocateSurfaceHelper(IVMRSurfa
 
     if (!*numbuffers || *numbuffers < allocinfo->MinBuffers)
     {
-        WARN("%lu surfaces requested (minimum %lu); returning E_INVALIDARG.\n",
+        WARN("%u surfaces requested (minimum %u); returning E_INVALIDARG.\n",
                 *numbuffers, allocinfo->MinBuffers);
         return E_INVALIDARG;
     }
@@ -2110,12 +2103,12 @@ static HRESULT WINAPI VMR9SurfaceAllocatorNotify_AllocateSurfaceHelper(IVMRSurfa
     }
     else
     {
-        FIXME("Unhandled flags %#lx.\n", allocinfo->dwFlags);
+        FIXME("Unhandled flags %#x.\n", allocinfo->dwFlags);
         return E_NOTIMPL;
     }
 
     if (FAILED(hr))
-        WARN("%lu/%lu surfaces allocated, hr %#lx.\n", i, *numbuffers, hr);
+        WARN("%u/%u surfaces allocated, hr %#x.\n", i, *numbuffers, hr);
 
     if (i >= allocinfo->MinBuffers)
     {
@@ -2177,7 +2170,7 @@ static HRESULT WINAPI mixer_control9_SetAlpha(IVMRMixerControl9 *iface, DWORD st
 {
     struct quartz_vmr *filter = impl_from_IVMRMixerControl9(iface);
 
-    FIXME("filter %p, stream %lu, alpha %.8e, stub!\n", filter, stream, alpha);
+    FIXME("filter %p, stream %u, alpha %.8e, stub!\n", filter, stream, alpha);
 
     return E_NOTIMPL;
 }
@@ -2186,7 +2179,7 @@ static HRESULT WINAPI mixer_control9_GetAlpha(IVMRMixerControl9 *iface, DWORD st
 {
     struct quartz_vmr *filter = impl_from_IVMRMixerControl9(iface);
 
-    FIXME("filter %p, stream %lu, alpha %p, stub!\n", filter, stream, alpha);
+    FIXME("filter %p, stream %u, alpha %p, stub!\n", filter, stream, alpha);
 
     return E_NOTIMPL;
 }
@@ -2195,7 +2188,7 @@ static HRESULT WINAPI mixer_control9_SetZOrder(IVMRMixerControl9 *iface, DWORD s
 {
     struct quartz_vmr *filter = impl_from_IVMRMixerControl9(iface);
 
-    FIXME("filter %p, stream %lu, z %lu, stub!\n", filter, stream, z);
+    FIXME("filter %p, stream %u, z %u, stub!\n", filter, stream, z);
 
     return E_NOTIMPL;
 }
@@ -2204,7 +2197,7 @@ static HRESULT WINAPI mixer_control9_GetZOrder(IVMRMixerControl9 *iface, DWORD s
 {
     struct quartz_vmr *filter = impl_from_IVMRMixerControl9(iface);
 
-    FIXME("filter %p, stream %lu, z %p, stub!\n", filter, stream, z);
+    FIXME("filter %p, stream %u, z %p, stub!\n", filter, stream, z);
 
     return E_NOTIMPL;
 }
@@ -2214,7 +2207,7 @@ static HRESULT WINAPI mixer_control9_SetOutputRect(IVMRMixerControl9 *iface,
 {
     struct quartz_vmr *filter = impl_from_IVMRMixerControl9(iface);
 
-    FIXME("filter %p, stream %lu, rect %s, stub!\n", filter, stream, debugstr_normalized_rect(rect));
+    FIXME("filter %p, stream %u, rect %s, stub!\n", filter, stream, debugstr_normalized_rect(rect));
 
     return E_NOTIMPL;
 }
@@ -2224,7 +2217,7 @@ static HRESULT WINAPI mixer_control9_GetOutputRect(IVMRMixerControl9 *iface,
 {
     struct quartz_vmr *filter = impl_from_IVMRMixerControl9(iface);
 
-    FIXME("filter %p, stream %lu, rect %p, stub!\n", filter, stream, rect);
+    FIXME("filter %p, stream %u, rect %p, stub!\n", filter, stream, rect);
 
     return E_NOTIMPL;
 }
@@ -2233,7 +2226,7 @@ static HRESULT WINAPI mixer_control9_SetBackgroundClr(IVMRMixerControl9 *iface,
 {
     struct quartz_vmr *filter = impl_from_IVMRMixerControl9(iface);
 
-    FIXME("filter %p, color #%06lx, stub!\n", filter, color);
+    FIXME("filter %p, color #%06x, stub!\n", filter, color);
 
     return E_NOTIMPL;
 }
@@ -2251,7 +2244,7 @@ static HRESULT WINAPI mixer_control9_SetMixingPrefs(IVMRMixerControl9 *iface, DW
 {
     struct quartz_vmr *filter = impl_from_IVMRMixerControl9(iface);
 
-    FIXME("filter %p, flags %#lx, stub!\n", filter, flags);
+    FIXME("filter %p, flags %#x, stub!\n", filter, flags);
 
     EnterCriticalSection(&filter->renderer.filter.filter_cs);
     filter->mixing_prefs = flags;
@@ -2348,7 +2341,7 @@ static HRESULT WINAPI mixer_bitmap9_SetAlphaBitmap(IVMRMixerBitmap9 *iface,
         const VMR9AlphaBitmap *bitmap)
 {
     FIXME("iface %p, bitmap %p, stub!\n", iface, bitmap);
-    TRACE("dwFlags %#lx, hdc %p, pDDS %p, rSrc %s, rDest %s, fAlpha %.8e, clrSrcKey #%06lx, dwFilterMode %#lx.\n",
+    TRACE("dwFlags %#x, hdc %p, pDDS %p, rSrc %s, rDest %s, fAlpha %.8e, clrSrcKey #%06x, dwFilterMode %#x.\n",
             bitmap->dwFlags, bitmap->hdc, bitmap->pDDS, wine_dbgstr_rect(&bitmap->rSrc),
             debugstr_normalized_rect(&bitmap->rDest), bitmap->fAlpha, bitmap->clrSrcKey, bitmap->dwFilterMode);
     return E_NOTIMPL;
@@ -2417,7 +2410,7 @@ static HRESULT WINAPI aspect_ratio_control9_SetAspectRatioMode(IVMRAspectRatioCo
 {
     struct quartz_vmr *filter = impl_from_IVMRAspectRatioControl9(iface);
 
-    TRACE("filter %p, mode %lu.\n", filter, mode);
+    TRACE("filter %p, mode %u.\n", filter, mode);
 
     EnterCriticalSection(&filter->renderer.filter.filter_cs);
     filter->aspect_mode = mode;
@@ -2434,139 +2427,6 @@ static const IVMRAspectRatioControl9Vtbl aspect_ratio_control9_vtbl =
     aspect_ratio_control9_SetAspectRatioMode,
 };
 
-static struct quartz_vmr *impl_from_IAMVideoAccelerator(IAMVideoAccelerator *iface)
-{
-    return CONTAINING_RECORD(iface, struct quartz_vmr, IAMVideoAccelerator_iface);
-}
-
-static HRESULT WINAPI video_accelerator_QueryInterface(IAMVideoAccelerator *iface, REFIID iid, void **out)
-{
-    struct quartz_vmr *filter = impl_from_IAMVideoAccelerator(iface);
-    return IPin_QueryInterface(&filter->renderer.sink.pin.IPin_iface, iid, out);
-}
-
-static ULONG WINAPI video_accelerator_AddRef(IAMVideoAccelerator *iface)
-{
-    struct quartz_vmr *filter = impl_from_IAMVideoAccelerator(iface);
-    return IPin_AddRef(&filter->renderer.sink.pin.IPin_iface);
-}
-
-static ULONG WINAPI video_accelerator_Release(IAMVideoAccelerator *iface)
-{
-    struct quartz_vmr *filter = impl_from_IAMVideoAccelerator(iface);
-    return IPin_Release(&filter->renderer.sink.pin.IPin_iface);
-}
-
-static HRESULT WINAPI video_accelerator_GetVideoAcceleratorGUIDs(
-        IAMVideoAccelerator *iface, DWORD *count, GUID *accelerators)
-{
-    FIXME("iface %p, count %p, accelerators %p, stub!\n", iface, count, accelerators);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI video_accelerator_GetUncompFormatsSupported(IAMVideoAccelerator *iface,
-        const GUID *accelerator, DWORD *count, DDPIXELFORMAT *formats)
-{
-    FIXME("iface %p, accelerator %s, count %p, formats %p, stub!\n",
-            iface, debugstr_guid(accelerator), count, formats);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI video_accelerator_GetInternalMemInfo(IAMVideoAccelerator *iface,
-        const GUID *accelerator, const AMVAUncompDataInfo *format_info, AMVAInternalMemInfo *mem_info)
-{
-    FIXME("iface %p, accelerator %s, format_info %p, mem_info %p, stub!\n",
-            iface, debugstr_guid(accelerator), format_info, mem_info);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI video_accelerator_GetCompBufferInfo(IAMVideoAccelerator *iface,
-        const GUID *accelerator, const AMVAUncompDataInfo *uncompressed_info,
-        DWORD *compressed_info_count, AMVACompBufferInfo *compressed_infos)
-{
-    FIXME("iface %p, accelerator %s, uncompressed_info %p, compressed_info_count %p, compressed_infos %p, stub!\n",
-            iface, debugstr_guid(accelerator), uncompressed_info, compressed_info_count, compressed_infos);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI video_accelerator_GetInternalCompBufferInfo(
-        IAMVideoAccelerator *iface, DWORD *count, AMVACompBufferInfo *infos)
-{
-    FIXME("iface %p, count %p, infos %p, stub!\n", iface, count, infos);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI video_accelerator_BeginFrame(IAMVideoAccelerator *iface, const AMVABeginFrameInfo *info)
-{
-    FIXME("iface %p, info %p, stub!\n", iface, info);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI video_accelerator_EndFrame(IAMVideoAccelerator *iface, const AMVAEndFrameInfo *info)
-{
-    FIXME("iface %p, info %p, stub!\n", iface, info);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI video_accelerator_GetBuffer(IAMVideoAccelerator *iface,
-        DWORD type_index, DWORD buffer_index, BOOL read_only, void **buffer, LONG *stride)
-{
-    FIXME("iface %p, type_index %lu, buffer_index %lu, read_only %d, buffer %p, stride %p, stub!\n",
-            iface, type_index, buffer_index, read_only, buffer, stride);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI video_accelerator_ReleaseBuffer(
-        IAMVideoAccelerator *iface, DWORD type_index, DWORD buffer_index)
-{
-    FIXME("iface %p, type_index %lu, buffer_index %lu, stub!\n", iface, type_index, buffer_index);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI video_accelerator_Execute(IAMVideoAccelerator *iface,
-        DWORD function, void *in_data, DWORD in_size, void *out_data,
-        DWORD out_size, DWORD buffer_count, const AMVABUFFERINFO *buffers)
-{
-    FIXME("iface %p, function %#lx, in_data %p, in_size %lu,"
-            " out_data %p, out_size %lu, buffer_count %lu, buffers %p, stub!\n",
-            iface, function, in_data, in_size, out_data, out_size, buffer_count, buffers);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI video_accelerator_QueryRenderStatus(IAMVideoAccelerator *iface,
-        DWORD type_index, DWORD buffer_index, DWORD flags)
-{
-    FIXME("iface %p, type_index %lu, buffer_index %lu, flags %#lx, stub!\n",
-            iface, type_index, buffer_index, flags);
-    return E_NOTIMPL;
-}
-
-static HRESULT WINAPI video_accelerator_DisplayFrame(
-        IAMVideoAccelerator *iface, DWORD index, IMediaSample *sample)
-{
-    FIXME("iface %p, index %lu, sample %p, stub!\n", iface, index, sample);
-    return E_NOTIMPL;
-}
-
-static const IAMVideoAcceleratorVtbl video_accelerator_vtbl =
-{
-    video_accelerator_QueryInterface,
-    video_accelerator_AddRef,
-    video_accelerator_Release,
-    video_accelerator_GetVideoAcceleratorGUIDs,
-    video_accelerator_GetUncompFormatsSupported,
-    video_accelerator_GetInternalMemInfo,
-    video_accelerator_GetCompBufferInfo,
-    video_accelerator_GetInternalCompBufferInfo,
-    video_accelerator_BeginFrame,
-    video_accelerator_EndFrame,
-    video_accelerator_GetBuffer,
-    video_accelerator_ReleaseBuffer,
-    video_accelerator_Execute,
-    video_accelerator_QueryRenderStatus,
-    video_accelerator_DisplayFrame,
-};
-
 static inline struct quartz_vmr *impl_from_IOverlay(IOverlay *iface)
 {
     return CONTAINING_RECORD(iface, struct quartz_vmr, IOverlay_iface);
@@ -2598,7 +2458,7 @@ static HRESULT WINAPI overlay_GetPalette(IOverlay *iface, DWORD *count, PALETTEE
 
 static HRESULT WINAPI overlay_SetPalette(IOverlay *iface, DWORD count, PALETTEENTRY *palette)
 {
-    FIXME("iface %p, count %lu, palette %p, stub!\n", iface, count, palette);
+    FIXME("iface %p, count %u, palette %p, stub!\n", iface, count, palette);
     return E_NOTIMPL;
 }
 
@@ -2647,7 +2507,7 @@ static HRESULT WINAPI overlay_GetVideoPosition(IOverlay *iface, RECT *source, RE
 
 static HRESULT WINAPI overlay_Advise(IOverlay *iface, IOverlayNotify *sink, DWORD flags)
 {
-    FIXME("iface %p, sink %p, flags %#lx, stub!\n", iface, sink, flags);
+    FIXME("iface %p, sink %p, flags %#x, stub!\n", iface, sink, flags);
     return E_NOTIMPL;
 }
 
@@ -2704,8 +2564,6 @@ static HRESULT vmr_create(IUnknown *outer, IUnknown **out, const CLSID *clsid)
     object->IVMRSurfaceAllocatorNotify9_iface.lpVtbl = &VMR9_SurfaceAllocatorNotify_Vtbl;
     object->IVMRWindowlessControl_iface.lpVtbl = &VMR7_WindowlessControl_Vtbl;
     object->IVMRWindowlessControl9_iface.lpVtbl = &VMR9_WindowlessControl_Vtbl;
-
-    object->IAMVideoAccelerator_iface.lpVtbl = &video_accelerator_vtbl;
     object->IOverlay_iface.lpVtbl = &overlay_vtbl;
 
     video_window_init(&object->window, &IVideoWindow_VTable,
@@ -2765,30 +2623,32 @@ static HRESULT WINAPI VMR9_ImagePresenter_QueryInterface(IVMRImagePresenter9 *if
 
 static ULONG WINAPI VMR9_ImagePresenter_AddRef(IVMRImagePresenter9 *iface)
 {
-    struct default_presenter *presenter = impl_from_IVMRImagePresenter9(iface);
-    ULONG refcount = InterlockedIncrement(&presenter->refCount);
+    struct default_presenter *This = impl_from_IVMRImagePresenter9(iface);
+    ULONG refCount = InterlockedIncrement(&This->refCount);
 
-    TRACE("%p increasing refcount to %lu.\n", presenter, refcount);
+    TRACE("(%p)->() AddRef from %d\n", iface, refCount - 1);
 
-    return refcount;
+    return refCount;
 }
 
 static ULONG WINAPI VMR9_ImagePresenter_Release(IVMRImagePresenter9 *iface)
 {
     struct default_presenter *This = impl_from_IVMRImagePresenter9(iface);
-    ULONG refcount = InterlockedDecrement(&This->refCount);
+    ULONG refCount = InterlockedDecrement(&This->refCount);
 
-    TRACE("%p decreasing refcount to %lu.\n", This, refcount);
+    TRACE("(%p)->() Release from %d\n", iface, refCount + 1);
 
-    if (!refcount)
+    if (!refCount)
     {
         DWORD i;
-
+        TRACE("Destroying\n");
         IDirect3D9_Release(This->d3d9_ptr);
 
+        TRACE("Number of surfaces: %u\n", This->num_surfaces);
         for (i = 0; i < This->num_surfaces; ++i)
         {
             IDirect3DSurface9 *surface = This->d3d9_surfaces[i];
+            TRACE("Releasing surface %p\n", surface);
             if (surface)
                 IDirect3DSurface9_Release(surface);
         }
@@ -2801,7 +2661,7 @@ static ULONG WINAPI VMR9_ImagePresenter_Release(IVMRImagePresenter9 *iface)
         free(This);
         return 0;
     }
-    return refcount;
+    return refCount;
 }
 
 static HRESULT WINAPI VMR9_ImagePresenter_StartPresenting(IVMRImagePresenter9 *iface, DWORD_PTR cookie)
@@ -2841,23 +2701,23 @@ static HRESULT WINAPI VMR9_ImagePresenter_PresentImage(IVMRImagePresenter9 *ifac
 
     if (FAILED(hr = IDirect3DDevice9_Clear(device, 0, NULL, D3DCLEAR_TARGET,
             D3DCOLOR_XRGB(0, 0, 0), 1.0f, 0)))
-        ERR("Failed to clear, hr %#lx.\n", hr);
+        ERR("Failed to clear, hr %#x.\n", hr);
 
     if (FAILED(hr = IDirect3DDevice9_BeginScene(device)))
-        ERR("Failed to begin scene, hr %#lx.\n", hr);
+        ERR("Failed to begin scene, hr %#x.\n", hr);
 
     if (FAILED(hr = IDirect3DDevice9_GetBackBuffer(device, 0, 0, D3DBACKBUFFER_TYPE_MONO, &backbuffer)))
     {
-        ERR("Failed to get backbuffer, hr %#lx.\n", hr);
+        ERR("Failed to get backbuffer, hr %#x.\n", hr);
         return hr;
     }
 
     if (FAILED(hr = IDirect3DDevice9_StretchRect(device, info->lpSurf, NULL, backbuffer, NULL, D3DTEXF_POINT)))
-        ERR("Failed to blit image, hr %#lx.\n", hr);
+        ERR("Failed to blit image, hr %#x.\n", hr);
     IDirect3DSurface9_Release(backbuffer);
 
     if (FAILED(hr = IDirect3DDevice9_EndScene(device)))
-        ERR("Failed to end scene, hr %#lx.\n", hr);
+        ERR("Failed to end scene, hr %#x.\n", hr);
 
     if (filter->aspect_mode == VMR9ARMode_LetterBox)
     {
@@ -2885,7 +2745,7 @@ static HRESULT WINAPI VMR9_ImagePresenter_PresentImage(IVMRImagePresenter9 *ifac
     }
 
     if (FAILED(hr = IDirect3DDevice9_Present(device, &src, &dst, NULL, NULL)))
-        ERR("Failed to present, hr %#lx.\n", hr);
+        ERR("Failed to present, hr %#x.\n", hr);
 
     return S_OK;
 }
@@ -2918,15 +2778,21 @@ static ULONG WINAPI VMR9_SurfaceAllocator_Release(IVMRSurfaceAllocator9 *iface)
     return IVMRImagePresenter9_Release(&presenter->IVMRImagePresenter9_iface);
 }
 
-static void adjust_surface_size(const D3DCAPS9 *caps, VMR9AllocationInfo *allocinfo)
+static HRESULT VMR9_SurfaceAllocator_SetAllocationSettings(struct default_presenter *This, VMR9AllocationInfo *allocinfo)
 {
+    D3DCAPS9 caps;
     UINT width, height;
+    HRESULT hr;
 
-    /* There are no restrictions on the size of offscreen surfaces. */
     if (!(allocinfo->dwFlags & VMR9AllocFlag_TextureSurface))
-        return;
+        /* Only needed for texture surfaces */
+        return S_OK;
 
-    if (!(caps->TextureCaps & D3DPTEXTURECAPS_POW2) || (caps->TextureCaps & D3DPTEXTURECAPS_SQUAREONLY))
+    hr = IDirect3DDevice9_GetDeviceCaps(This->d3d9_dev, &caps);
+    if (FAILED(hr))
+        return hr;
+
+    if (!(caps.TextureCaps & D3DPTEXTURECAPS_POW2) || (caps.TextureCaps & D3DPTEXTURECAPS_SQUAREONLY))
     {
         width = allocinfo->dwWidth;
         height = allocinfo->dwHeight;
@@ -2942,7 +2808,7 @@ static void adjust_surface_size(const D3DCAPS9 *caps, VMR9AllocationInfo *alloci
         FIXME("NPOW2 support missing, not using proper surfaces!\n");
     }
 
-    if (caps->TextureCaps & D3DPTEXTURECAPS_SQUAREONLY)
+    if (caps.TextureCaps & D3DPTEXTURECAPS_SQUAREONLY)
     {
         if (height > width)
             width = height;
@@ -2953,6 +2819,8 @@ static void adjust_surface_size(const D3DCAPS9 *caps, VMR9AllocationInfo *alloci
 
     allocinfo->dwHeight = height;
     allocinfo->dwWidth = width;
+
+    return hr;
 }
 
 static UINT d3d9_adapter_from_hwnd(IDirect3D9 *d3d9, HWND hwnd, HMONITOR *mon_out)
@@ -3013,7 +2881,7 @@ static HRESULT WINAPI VMR9_SurfaceAllocator_InitializeDevice(IVMRSurfaceAllocato
             NULL, D3DCREATE_MIXED_VERTEXPROCESSING, &d3dpp, &device);
     if (FAILED(hr))
     {
-        ERR("Failed to create device, hr %#lx.\n", hr);
+        ERR("Could not create device: %08x\n", hr);
         return hr;
     }
 
@@ -3031,13 +2899,19 @@ static HRESULT WINAPI VMR9_SurfaceAllocator_InitializeDevice(IVMRSurfaceAllocato
     if (!(This->d3d9_surfaces = calloc(*numbuffers, sizeof(IDirect3DSurface9 *))))
         return E_OUTOFMEMORY;
 
-    adjust_surface_size(&caps, info);
+    hr = VMR9_SurfaceAllocator_SetAllocationSettings(This, info);
+    if (FAILED(hr))
+        ERR("Setting allocation settings failed: %08x\n", hr);
+
+    if (SUCCEEDED(hr))
+    {
+        hr = IVMRSurfaceAllocatorNotify9_AllocateSurfaceHelper(This->SurfaceAllocatorNotify, info, numbuffers, This->d3d9_surfaces);
+        if (FAILED(hr))
+            ERR("Allocating surfaces failed: %08x\n", hr);
+    }
 
-    hr = IVMRSurfaceAllocatorNotify9_AllocateSurfaceHelper(This->SurfaceAllocatorNotify,
-            info, numbuffers, This->d3d9_surfaces);
     if (FAILED(hr))
     {
-        ERR("Failed to allocate surfaces, hr %#lx.\n", hr);
         IVMRSurfaceAllocator9_TerminateDevice(This->pVMR9->allocator, This->pVMR9->cookie);
         return hr;
     }
@@ -3049,7 +2923,7 @@ static HRESULT WINAPI VMR9_SurfaceAllocator_InitializeDevice(IVMRSurfaceAllocato
 
 static HRESULT WINAPI VMR9_SurfaceAllocator_TerminateDevice(IVMRSurfaceAllocator9 *iface, DWORD_PTR cookie)
 {
-    TRACE("iface %p, cookie %#Ix.\n", iface, cookie);
+    TRACE("iface %p, cookie %#lx.\n", iface, cookie);
 
     return S_OK;
 }
@@ -3113,6 +2987,8 @@ static IDirect3D9 *init_d3d9(HMODULE d3d9_handle)
 static HRESULT VMR9DefaultAllocatorPresenterImpl_create(struct quartz_vmr *parent, LPVOID * ppv)
 {
     struct default_presenter *object;
+    HRESULT hr = S_OK;
+    int i;
 
     if (!(object = calloc(1, sizeof(*object))))
         return E_OUTOFMEMORY;
@@ -3125,6 +3001,24 @@ static HRESULT VMR9DefaultAllocatorPresenterImpl_create(struct quartz_vmr *paren
         return VFW_E_DDRAW_CAPS_NOT_SUITABLE;
     }
 
+    i = 0;
+    do
+    {
+        D3DDISPLAYMODE mode;
+
+        hr = IDirect3D9_EnumAdapterModes(object->d3d9_ptr, i++, D3DFMT_X8R8G8B8, 0, &mode);
+	if (hr == D3DERR_INVALIDCALL) break; /* out of adapters */
+    } while (FAILED(hr));
+    if (FAILED(hr))
+        ERR("HR: %08x\n", hr);
+    if (hr == D3DERR_NOTAVAILABLE)
+    {
+        ERR("Format not supported\n");
+        IDirect3D9_Release(object->d3d9_ptr);
+        free(object);
+        return VFW_E_DDRAW_CAPS_NOT_SUITABLE;
+    }
+
     object->IVMRImagePresenter9_iface.lpVtbl = &VMR9_ImagePresenter;
     object->IVMRSurfaceAllocator9_iface.lpVtbl = &VMR9_SurfaceAllocator;
 
